commit 1c4d223d37d067f5d372688c0c0cc5a05d977df7
Author: Marek Polacek <polacek@redhat.com>
Date:   Tue Aug 4 09:35:25 2020 -0400

    c++: Template keyword following :: [PR96082]
    
    In r9-4235 I tried to make sure that the template keyword follows
    a nested-name-specifier.  :: is a valid nested-name-specifier, so
    I also have to check 'globalscope' before giving the error.
    
    gcc/cp/ChangeLog:
    
            PR c++/96082
            * parser.c (cp_parser_elaborated_type_specifier): Allow
            'template' following ::.
    
    gcc/testsuite/ChangeLog:
    
            PR c++/96082
            * g++.dg/template/template-keyword3.C: New test.
    
    (cherry picked from commit 97def1f34c134d78d4423e9ac3e9b262417ea390)

diff --git a/gcc/cp/parser.c b/gcc/cp/parser.c
index ff0b2ed1ff0..5de13d0498f 100644
--- a/gcc/cp/parser.c
+++ b/gcc/cp/parser.c
@@ -18745,7 +18745,7 @@ cp_parser_elaborated_type_specifier (cp_parser* parser,
       if (!template_p)
 	cp_parser_parse_tentatively (parser);
       /* The `template' keyword must follow a nested-name-specifier.  */
-      else if (!nested_name_specifier)
+      else if (!nested_name_specifier && !globalscope)
 	{
 	  cp_parser_error (parser, "%<template%> must follow a nested-"
 			   "name-specifier");
